$Comment

Ŀ
     This demonstration is written to be compiled using BASM version 3.1      
                                                                              
 This demo's some 640x480x16 graphics, loops, nesting, and parameter passing. 
 It also uses the simple RND function which produces randoms between 0 & 256  
        This will only work correctly on a color EGA or VGA monitor.          
Ĵ
    This program was written by Kevin T. Diggins, creator of BASM  (c) 1995   


$Comment


$Com                               'generate a .COM file

Screen 12                        'set screen to 640 x 480 and 16 colors

CONST Black = 0
CONST Red   = 4
CONST Green = 10

Gtext (230,50, "Press any key to quit",Red,Black)

Gtext (200,450,"Random Dots in Random",Green,Black)

do
  z = instat                      'loop until a key is pressed
  if z then exit loop
  kol = rnd                       'pick a color
  kol = kol mod 256               'keep it in the range of 0 to 15
  Gtext (375,450,"Colors",Kol,Black)

  for iterations = 1 to 3         'plot (32766 * 3) dots
    for a = 1 to 4000           'do this many iterations
      x1 = rnd + 180            'scale x ordinate
      y1 = rnd + 120            'scale y ordinate
      pset x1,y1,kol            'plot it in the current color
    next
  next
loop

screen 0                           'restore text mode when a key is pressed




SUB Gtext (XX,YY,A$,FG,BG)
'---------------------------------------------
'Draws a string of characters in graphics mode
'** Note ** XX,YY are pixel coordinates
'---------------------------------------------
LOCAL A,X,Y,LenA,B$
X = XX
Y = YY
LenA = LEN(A$)
FOR A = 1 TO LenA
  B$ = MID$(A$,A,1)
  DrawEgaChar(X,Y,B$,FG,BG)
  INCR X,8
NEXT
END SUB



SUB DrawEGAChar (XX,YY,A$,FG,BG)
'--------------------------------------
'This routine draws a single character
'** Note ** XX,YY are pixel coordinates
'--------------------------------------
LOCAL A,B,C,D,E,X,Y,OFS1,OFS2,B$

X  =  XX
Y  =  YY
B$ =  A$
A  =  ASC(B$)

DEF SEG  = &HF000       'point to rom character set segment
OFS1 = A * 8 + &hFA6D

FOR B = 1 TO 8
  OFS2 = OFS1 + B
  C = PEEK(OFS2)
  IF C = 0 THEN
    X = XX
    INCR Y
  ELSE
    FOR D = 7 TO 0 STEP -1
      E = Pow (2,D)
      IF C < E THEN
        IF FG = 1 THEN
          PSET (X,Y),FG
        ELSE
          PSET (X,Y),BG
        END IF
        INCR X
      ELSE
        IF FG = 1 THEN
          PSET (X,Y),BG
        ELSE
          PSET (X,Y),FG
        END IF
        INCR X
        E = Pow (2,D)
        C = C - E
      END IF
    NEXT
    INCR Y
    X = XX
  END IF
NEXT
END SUB
