Use.GetCursor = %True


SUB DoTwo
? #2,
? #2,
END SUB


IF Use.Concat2 = %True THEN
'=========================================================================
'  Do NOT Move this Block ... it is a speedup for the EmitConcatCode SUB
'=========================================================================
  Use.Concat   = %True
  Use.Len     =  %True
  Use.Work0   =  %True
  Use.Work1   =  %True
END IF



IF Use.GetCursor THEN
  DoTwo
  ? #2,"GetCursor Proc Near
  ? #2,"Mov  AH,3
  ? #2,"Xor  BH,BH
  ? #2,"Int  10h
  ? #2,"Xor  AX,AX
  ? #2,"Mov  AL,DL
  ? #2,"Inc  AL
  ? #2,"Mov  $Xcur,AX
  ? #2,"Mov  AL,DH
  ? #2,"Inc  AL
  ? #2,"Mov  $Ycur,AX
  ? #2,"Ret"
  ? #2,"GetCursor Endp
  DoTwo
END IF


IF Use.SetCursor THEN
  DoTwo
  ? #2,"SetCursor Proc Near"
  ? #2,"Mov  DX,$Xcur"
  ? #2,"Dec  DL"
  ? #2,"Mov  AX,$Ycur"
  ? #2,"Mov  DH,AL"
  ? #2,"Dec  DH"
  ? #2,"Mov  AH,2"
  ? #2,"Int  10h"
  ? #2,"Ret"
  ? #2,"SetCursor Endp"
  DoTwo
END IF


IF Use.MoveStr THEN
  DoTwo
  ? #2,"MoveStr Proc Near
  ? #2,"Cld
  ? #2,"MoveStr1:
  ? #2,"Lodsb
  ? #2,"Stosb
  ? #2,"Or  AL,AL
  ? #2,"Jnz MoveStr1
  ? #2,"Ret
  ? #2,"MoveStr Endp
  DoTwo
END IF


IF Use.Len THEN
  DoTwo
  ? #2,"Len Proc Near
  ? #2,"Push CX
  ? #2,"Push SI
  ? #2,"Push DI
  ? #2,"Mov  DI,SI
  ? #2,"Xor  AL,AL
  ? #2,"Mov  CX,0ffffh
  ? #2,"Cld
  ? #2,"Repnz Scasb
  ? #2,"Not  CX
  ? #2,"Dec  CX
  ? #2,"Mov  AX,CX
  ? #2,"Pop  DI
  ? #2,"Pop  SI
  ? #2,"Pop  CX
  ? #2,"Ret
  ? #2,"Len Endp
  DoTwo
END IF



IF Use.Concat THEN
  DoTwo
  ? #2,"Concat Proc Near
  ? #2,"Push CX
  ? #2,"Push DI
  ? #2,"Push SI
  ? #2,"Push SI
  ? #2,"Push DI
  ? #2,"Pop  SI
  ? #2,"Call Len
  ? #2,"Mov  BX,AX
  ? #2,"Pop  SI
  ? #2,"Call Len
  ? #2,"Mov  CX,AX
  ? #2,"Inc  CX
  ? #2,"Pop  SI
  ? #2,"Pop  DI
  ? #2,"Add  DI,BX
  ? #2,"Cld
  ? #2,"Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI]
  ? #2,"Pop  CX
  ? #2,"Ret
  ? #2,"Concat Endp
  DoTwo
END IF



IF Use.Concat2 = %True THEN
  DoTwo
  ? #2,"Concat_2 Proc Near
  ? #2,"Mov  SI,Offset $_1_"
  ? #2,"Mov  DI,Offset $_0_"
  ? #2,"Call Concat
  ? #2,"Ret
  ? #2,"Concat_2 Endp
  DoTwo
END IF



IF Use.Strcompare THEN
  DoTwo
  ? #2,"StrCompare Proc Near
  ? #2,"Push AX
  ? #2,"Push DI
  ? #2,"Push SI
  ? #2,"Cld
  ? #2,"StrCmp1:
  ? #2,"Lodsb
  ? #2,"Scasb
  ? #2,"Jne  StrCmp2
  ? #2,"Or   AL,AL
  ? #2,"Jne  StrCmp1
  ? #2,"StrCmp2:
  ? #2,"Pop  SI
  ? #2,"Pop  DI
  ? #2,"Pop  AX
  ? #2,"Ret
  ? #2,"StrCompare Endp
  DoTwo
END IF


IF Use.Color THEN
  DoTwo
  ? #2,"SetAttribute Proc Near
  ? #2,"Push CX
  ? #2,"Mov  AX,BgColor
  ? #2,"Mov  BX,FgColor
  ? #2,"Shl  AX,4
  ? #2,"Add  AX,BX
  ? #2,"Xor  Ah,Ah
  ? #2,"Cmp  AX,128
  ? #2,"Jl   SkipXor
  ? #2,"Xor  AX,128
  ? #2,"SkipXor:
  ? #2,"Mov  $Attr,AX
  ? #2,"Pop  CX
  ? #2,"Ret
  ? #2,"SetAttribute Endp
  DoTwo
END IF


IF Use.Bin THEN
  DoTwo
  ? #2,"Bin$ Proc Near
  ? #2,"Mov  DI,Offset $_1_
  ? #2,"Mov  [DI],Byte Ptr 0
  ? #2,"Mov  DI,Offset $_0_
  ? #2,"Mov  CX,8
  ? #2,"Xor  BX,BX
  ? #2,"Bin1:
  ? #2,"Rol  DL,1
  ? #2,"Mov  AL,DL
  ? #2,"And  AL,1
  ? #2,"Add  AL,30H
  ? #2,"Mov  [DI+BX],AL
  ? #2,"Inc  BX
  ? #2,"Loop Bin1
  ? #2,"Xor  AX,AX
  ? #2,"Mov  [DI+BX],AL
  ? #2,"Ret
  ? #2,"Bin$ Endp
  DoTwo
END IF


IF Use.ChangeAttr THEN
  DoTwo
  ? #2,"ChangeAttr Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Sub  SP,8
  ? #2,"Mov  AX,[BP+6]
  ? #2,"IMul AX,160
  ? #2,"Mov  [BP-2],AX
  ? #2,"Sub  AX,160
  ? #2,"Add  AX,[BP+4]
  ? #2,"Add  AX,[BP+4]
  ? #2,"Dec  AX
  ? #2,"Mov  [BP-2],AX
  ? #2,"Mov  [BP-4],AX
  ? #2,"Add  AX,[BP+8]
  ? #2,"Add  AX,[BP+8]
  ? #2,"Dec  AX
  ? #2,"Dec  AX
  ? #2,"Mov  [BP-4],AX
  ? #2,"Mov  [BP-8],Word Ptr 0
  ? #2,"Call VideoCard
  ? #2,"Add  AX,[BP-8]
  ? #2,"Mov  DefSeg,AX
  ? #2,"Mov  AX,[BP-2]
  ? #2,"Dec  AX
  ? #2,"Dec  AX
  ? #2,"Mov  [BP-6],AX
  ? #2,"CA_1:
  ? #2,"Mov  AX,2
  ? #2,"Add  [BP-6],AX
  ? #2,"Mov  AX,[BP-6]
  ? #2,"Cmp  AX,[BP-4]
  ? #2,"Jg   CA_2
  ? #2,"Mov  DI,[BP-6]
  ? #2,"Mov  AX,[BP+12]
  ? #2,"Mov  BX,[BP+10]
  ? #2,"Shl  AX,4
  ? #2,"Add  BX,AX
  ? #2,"Call Poke
  ? #2,"Jmp  CA_1
  ? #2,"CA_2:
  ? #2,"Mov  SP,BP
  ? #2,"Pop  BP
  ? #2,"Ret  10
  ? #2,"ChangeAttr Endp
  DoTwo
END IF


IF Use.VideoCard THEN
  DoTwo
  ? #2,"VideoCard Proc Near
  ? #2,"Mov  AH,0FH
  ? #2,"Int  10H
  ? #2,"And  AL,0FFH
  ? #2,"Cmp  AL,7
  ? #2,"Je   VC1
  ? #2,"Mov  AX,0B800H
  ? #2,"Jmp  VC2
  ? #2,"VC1:
  ? #2,"Mov  AX,0B000H
  ? #2,"VC2:
  ? #2,"Ret
  ? #2,"VideoCard Endp
  DoTwo
END IF


IF Use.Frame THEN
  DoTwo
  ? #2,"Frame Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Sub  SP,10
  ? #2,"Xor  AX,AX"
  ? #2,"Mov  [BP-2],AX
  ? #2,"Mov  [BP-4],AX
  ? #2,"Mov  [BP-6],AX
  ? #2,"Mov  DI,Offset $_3_
  ? #2,"Mov  [DI],Byte Ptr 0"
  ? #2,"Mov  AX,[BP+8]
  ? #2,"Sub  AX,[BP+4]
  ? #2,"Dec  AX
  ? #2,"Mov  [BP-2],AX
  ? #2,"Mov  DI,Offset $_0_
  ? #2,"Mov  [DI],Byte Ptr 0"
  ? #2,"Mov  SI,Offset $Frm1
  ? #2,"Mov  DI,Offset $_0_
  ? #2,"Call Concat
  ? #2,"Push Offset $Frm2
  ? #2,"Push [BP-2]
  ? #2,"Call Repeat$
  ? #2,"Call Concat_2
  ? #2,"Mov  SI,Offset $Frm3
  ? #2,"Mov  DI,Offset $_0_
  ? #2,"Call Concat
  ? #2,"Mov  SI,Offset $_0_
  ? #2,"Mov  DI,Offset $_3_
  ? #2,"Call MoveStr
  ? #2,"Mov  AX,[BP+6]
  ? #2,"Mov  $Ycur,AX
  ? #2,"Mov  AX,[BP+4]
  ? #2,"Mov  $Xcur,AX
  ? #2,"Mov  SI,Offset $_3_
  ? #2,"Call PrintStr
  ? #2,"Call SetCursor
  ? #2,"Call DoCrLf
  ? #2,"Mov  DI,Offset $_0_
  ? #2,"Mov  [DI],Byte Ptr 0"
  ? #2,"Mov  SI,Offset $Frm4
  ? #2,"Mov  DI,Offset $_0_
  ? #2,"Call Concat
  ? #2,"Push Offset $pace
  ? #2,"Push [BP-2]
  ? #2,"Call Repeat$
  ? #2,"Call Concat_2
  ? #2,"Mov  SI,Offset $Frm4
  ? #2,"Mov  DI,Offset $_0_
  ? #2,"Call Concat
  ? #2,"Mov  SI,Offset $_0_
  ? #2,"Mov  DI,Offset $_3_
  ? #2,"Call MoveStr
  ? #2,"Mov  AX,[BP+6]
  ? #2,"Inc  AX
  ? #2,"Mov  [BP-4],AX
  ? #2,"Mov  AX,[BP+10]
  ? #2,"Sub  AX,[BP+6]
  ? #2,"Mov  [BP-6],AX
  ? #2,"Mov  AX,[BP-6]
  ? #2,"Mov  [BP-8],AX
  ? #2,"Mov  AX,[BP-4]
  ? #2,"Dec  AX
  ? #2,"Mov  [BP-2],AX
  ? #2,"FrmL_01:
  ? #2,"Inc  Word Ptr[BP-2]
  ? #2,"Mov  AX,[BP-2]
  ? #2,"Cmp  AX,[BP+10]
  ? #2,"Jle  FrmL_01_OK
  ? #2,"Jmp  FrmL_01A
  ? #2,"Mov  AX,[BP-6]
  ? #2,"Cmp  AX,[BP-2]
  ? #2,"Jg   FrmL_01A
  ? #2,"FrmL_01_OK:
  ? #2,"Mov  AX,[BP-2]
  ? #2,"Mov  $Ycur,AX
  ? #2,"Mov  AX,[BP+4]
  ? #2,"Mov  $Xcur,AX
  ? #2,"Mov  SI,Offset $_3_
  ? #2,"Call PrintStr
  ? #2,"Call SetCursor
  ? #2,"Call DoCrLf
  ? #2,"Jmp  FrmL_01
  ? #2,"FrmL_01A:
  ? #2,"Mov  AX,[BP+8]
  ? #2,"Sub  AX,[BP+4]
  ? #2,"Dec  AX
  ? #2,"Mov  [BP-2],AX
  ? #2,"Mov  DI,Offset $_0_
  ? #2,"Mov  [DI],Byte Ptr 0"
  ? #2,"Mov  SI,Offset $Frm5
  ? #2,"Mov  DI,Offset $_0_
  ? #2,"Call Concat
  ? #2,"Push Offset $Frm2
  ? #2,"Push [BP-2]
  ? #2,"Call Repeat$
  ? #2,"Call Concat_2
  ? #2,"Mov  SI,Offset $Frm6
  ? #2,"Mov  DI,Offset $_0_
  ? #2,"Call Concat
  ? #2,"Mov  SI,Offset $_0_
  ? #2,"Mov  DI,Offset $_3_
  ? #2,"Call MoveStr
  ? #2,"Mov  AX,[BP+10]
  ? #2,"Mov  $Ycur,AX
  ? #2,"Mov  AX,[BP+4]
  ? #2,"Mov  $Xcur,AX
  ? #2,"Mov  SI,Offset $_3_
  ? #2,"Call PrintStr
  ? #2,"Call SetCursor
  ? #2,"Mov  SP,BP
  ? #2,"Pop  BP
  ? #2,"Ret  08
  ? #2,"Frame Endp
  DoTwo
END IF


IF Use.Verify THEN
  DoTwo
  ? #2,"Verify Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Sub  SP,8
  ? #2,"Mov  SI,[BP+4]
  ? #2,"Call Len
  ? #2,"Mov  [BP-4],AX
  ? #2,"Mov  SI,[BP+6]
  ? #2,"Call Len
  ? #2,"Mov  [BP-2],AX
  ? #2,"Mov  [BP-8],Word Ptr 0
  ? #2,"Ver1:
  ? #2,"Inc  Word Ptr[BP-8]
  ? #2,"Mov  AX,[BP-8]
  ? #2,"Cmp  AX,[BP-4]
  ? #2,"Jg   Ver_2
  ? #2,"Mov  DI,Offset $_0_
  ? #2,"Mov  [DI],Byte Ptr 0"
  ? #2,"Mov  SI,[BP+4]
  ? #2,"Mov  DI,Offset $_1_
  ? #2,"Add  SI,[BP-8]
  ? #2,"Dec  SI
  ? #2,"Mov  CX,1
  ? #2,"Cld
  ? #2,"Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI]
  ? #2,"Xor  AX,AX
  ? #2,"Mov  [DI],AL
  ? #2,"Call Concat_2
  ? #2,"Mov  SI,Offset $_0_
  ? #2,"Mov  DI,Offset $_2_
  ? #2,"Call MoveStr
  ? #2,"Mov  DI,[BP+6]
  ? #2,"Mov  SI,Offset $_2_
  ? #2,"Call _Instr
  ? #2,"Mov  [BP-6],AX
  ? #2,"Cmp  [BP-6],Word Ptr 0
  ? #2,"Jne  Ver1
  ? #2,"Ver_2:
  ? #2,"Cmp  [BP-6],Word Ptr 0
  ? #2,"Jg   Ver_2a
  ? #2,"Xor  AX,AX"
  ? #2,"Jmp  Ver_3
  ? #2,"Ver_2a:
  ? #2,"Mov  AX,-1
  ? #2,"Ver_3:
  ? #2,"Mov  SP,BP
  ? #2,"Pop  BP
  ? #2,"Ret  04
  ? #2,"Verify Endp
  DoTwo
END IF


IF Use.Rnd THEN
  DoTwo
  ? #2,"Rnd  Proc Near"
  ? #2,"Jmp  _RndA
  ? #2,"Ran1 DW 13579
  ? #2,"Ran2 DW 24680
  ? #2,"Ran3 DW 31415
  ? #2,"_RndA:
  ? #2,"Xor  AX,AX
  ? #2,"Int  1AH
  ? #2,"Add  AX,DX
  ? #2,"Mov  AX,Ran1
  ? #2,"Mov  BX,Ran2
  ? #2,"Mov  CX,Ran3
  ? #2,"Add  DL,AH
  ? #2,"Add  DH,CL
  ? #2,"Add  AX,BX
  ? #2,"Add  AX,CX
  ? #2,"Add  AX,DX
  ? #2,"Mov  Ran1,AX
  ? #2,"Add  AX,BX
  ? #2,"Add  AX,CX
  ? #2,"Add  AX,DX
  ? #2,"Mov  Ran2,AX
  ? #2,"Shl  AX,1
  ? #2,"Inc  BX
  ? #2,"Add  DX,AX
  ? #2,"Add  AX,BX
  ? #2,"Add  AX,CX
  ? #2,"Add  AX,DX
  ? #2,"Mov  Ran3,AX
  ? #2,"Xor  AH,AH
  ? #2,"Ret
  ? #2,"Rnd Endp
  DoTwo
END IF


IF Use.Random THEN
  DoTwo
  ? #2,"Random Proc Near
  ? #2,"Jmp    _RndB
  ? #2,"Rand1  DW 13579
  ? #2,"Rand2  DW 24680
  ? #2,"Rand3  DW 31415
  ? #2,"Rand4  DW 0
  ? #2,"_RndB:
  ? #2,"Mov  Rand4,ax
  ? #2,"Xor  AX,AX
  ? #2,"Int  1AH
  ? #2,"Add  AX,DX
  ? #2,"Mov  AX,Rand1
  ? #2,"Mov  BX,Rand2
  ? #2,"Mov  CX,Rand3
  ? #2,"Add  DL,AH
  ? #2,"Add  DH,CL
  ? #2,"Add  AX,BX
  ? #2,"Add  AX,CX
  ? #2,"Add  AX,DX
  ? #2,"Mov  Rand1,AX
  ? #2,"Add  AX,BX
  ? #2,"Add  AX,CX
  ? #2,"Add  AX,DX
  ? #2,"Mov  Rand2,AX
  ? #2,"Shl  AX,1
  ? #2,"Inc  BX
  ? #2,"Add  DX,AX
  ? #2,"Add  AX,BX
  ? #2,"Add  AX,CX
  ? #2,"Add  AX,DX
  ? #2,"Mov  Rand3,AX
  ? #2,"Mov  AH,DL
  ? #2,"Cmp  AX,0
  ? #2,"Jge  R1
  ? #2,"Not  AX
  ? #2,"R1:
  ? #2,"Cmp  AX,Rand4
  ? #2,"Jle  R2
  ? #2,"Sub  AX,Rand4
  ? #2,"Jmp  R1
  ? #2,"R2:
  ? #2,"Ret
  ? #2,"Random Endp
  DoTwo
END IF



IF Use.Remove THEN
  DoTwo
  ? #2,"Remove$ Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Sub  SP,8
  ? #2,"Mov  DI,[BP+04]
  ? #2,"Mov  SI,[BP+06]
  ? #2,"Call _Instr
  ? #2,"Cmp  AX,0
  ? #2,"Jne  Remov_1
  ? #2,"Call ClrWork
  ? #2,"Mov  SI,[BP+04]
  ? #2,"Mov  DI,Offset $_1_
  ? #2,"Call MoveStr
  ? #2,"Mov  SP,BP
  ? #2,"Pop  BP
  ? #2,"Ret  04
  ? #2,"Remov_1:
  ? #2,"Call ClrWork
  ? #2,"Mov  SI,[BP+04]
  ? #2,"Mov  DI,Offset $_2_
  ? #2,"Call MoveStr
  ? #2,"Mov  SI,[BP+06]
  ? #2,"Call Len
  ? #2,"Mov  [BP-4],AX
  ? #2,"Remov_2:
  ? #2,"Mov  DI,Offset $_2_
  ? #2,"Mov  SI,[BP+06]
  ? #2,"Call _Instr
  ? #2,"Mov  [BP-2],AX
  ? #2,"Cmp  Word Ptr[BP-2],0
  ? #2,"Jne  Remov_3
  ? #2,"Jmp  Remov_6
  ? #2,"Remov_3:
  ? #2,"Mov  AX,[BP-2]
  ? #2,"Dec  AX
  ? #2,"Mov  [BP-6],AX
  ? #2,"Mov  AX,[BP-2]
  ? #2,"Add  AX,[BP-4]
  ? #2,"Mov  [BP-8],AX
  ? #2,"Cmp  Word Ptr[BP-6],0
  ? #2,"Jne  Remov_4
  ? #2,"Call ClrWork
  ? #2,"Mov  SI,Offset $Empty
  ? #2,"Mov  DI,Offset $_3_
  ? #2,"Call MoveStr
  ? #2,"Jmp Remov_5
  ? #2,"Remov_4:
  ? #2,"Call ClrWork
  ? #2,"Mov  SI,Offset $_2_
  ? #2,"Mov  AX,1
  ? #2,"Mov  BX,[BP-6]
  ? #2,"Call Mid$
  ? #2,"Call Concat_2
  ? #2,"Mov  DI,Offset $_3_
  ? #2,"Call Assign
  ? #2,"Remov_5:
  ? #2,"Call ClrWork
  ? #2,"Mov  SI,Offset $_2_
  ? #2,"Mov  AX,[BP-8]
  ? #2,"Mov  BX,MaxString
  ? #2,"Call Mid$
  ? #2,"Call Concat_2
  ? #2,"Mov  DI,Offset $_4_
  ? #2,"Call Assign
  ? #2,"Call ClrWork
  ? #2,"Mov  SI,Offset $_3_
  ? #2,"Call ConcatWork
  ? #2,"Mov  SI,Offset $_4_
  ? #2,"Call ConcatWork
  ? #2,"Mov  DI,Offset $_2_
  ? #2,"Call Assign
  ? #2,"Jmp Remov_2
  ? #2,"Remov_6:
  ? #2,"Call ClrWork
  ? #2,"Mov  SI,Offset $_2_
  ? #2,"Mov  DI,Offset $_1_
  ? #2,"Call MoveStr
  ? #2,"Mov  SP,BP
  ? #2,"Pop  BP
  ? #2,"Ret  04
  ? #2,"Remove$ Endp
  DoTwo
END IF


IF Use.Shell THEN
  DoTwo
  ? #2,"Shell Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Sub  SP,6
  ? #2,"Xor  AX,AX
  ? #2,"Xor  BX,BX
  ? #2,"Mov  CX,MaxString
  ? #2,"Shell_1:
  ? #2,"Mov  DI,Offset $_0_
  ? #2,"Mov  [DI+BX],AL
  ? #2,"Mov  DI,Offset $_1_
  ? #2,"Mov  [DI+BX],AL
  ? #2,"Mov  DI,Offset $_2_
  ? #2,"Mov  [DI+BX],AL
  ? #2,"Inc  BX
  ? #2,"Loop Shell_1
  ? #2,"Xor  AX,AX
  ? #2,"Mov  [BP-2],AX
  ? #2,"Mov  SI,[BP+4]
  ? #2,"Call Len
  ? #2,"Mov  [BP-2],AX
  ? #2,"Cmp  [BP-2],Word Ptr 0
  ? #2,"Jle  Shell_2
  ? #2,"Add  [BP-2],Word Ptr 4
  ? #2,"Mov  DI,Offset $_0_
  ? #2,"Mov  [DI],Byte Ptr 0"
  ? #2,"Mov  DI,Offset $_1_
  ? #2,"Mov  AX,[BP-2]
  ? #2,"Mov  [Byte Ptr DI],AX
  ? #2,"Xor  BX,BX
  ? #2,"Mov  [Byte Ptr DI+1],BX
  ? #2,"Call Concat_2
  ? #2,"Mov  SI,Offset $_0_
  ? #2,"Mov  DI,Offset $_2_
  ? #2,"Call MoveStr
  ? #2,"Shell_2:
  ? #2,"Cmp  [BP-2],Word Ptr 0
  ? #2,"Jle  Shell_3
  ? #2,"Mov  DI,Offset $_0_
  ? #2,"Mov  [DI],Byte Ptr 0"
  ? #2,"Mov  SI,Offset $_2_
  ? #2,"Mov  DI,Offset $_0_
  ? #2,"Call Concat
  ? #2,"Mov  SI,Offset ShellSwitch
  ? #2,"Mov  DI,Offset $_0_
  ? #2,"Call Concat
  ? #2,"Mov  SI,Offset [BP+4]
  ? #2,"Mov  DI,Offset $_0_
  ? #2,"Call Concat
  ? #2,"Mov  DI,Offset $_1_
  ? #2,"Mov  AX,13
  ? #2,"Mov  [Byte Ptr DI],AX
  ? #2,"Xor  BX,BX
  ? #2,"Mov  [Byte Ptr DI+1],BX
  ? #2,"Call Concat_2
  ? #2,"Mov  SI,Offset $_0_
  ? #2,"Mov  DI,Offset $_2_
  ? #2,"Call MoveStr
  ? #2,"Shell_3:
  ? #2,"Mov  DI,Offset $_0_
  ? #2,"Mov  [DI],Byte Ptr 0"
  ? #2,"Mov  SI,Offset $_2_
  ? #2,"Mov  DI,Offset $_0_
  ? #2,"Call MoveStr

'ParmBlk holds the parameter Pointers to the EXEC function
'Comspec holds the string C:\Command.Com
'DummyFCB 16 byte safe area

  ? #2,"Push DS"
  ? #2,"Pop  DX"
  ? #2,"Xor  AX,AX"                            'Zero out accumulator
  ? #2,"Mov  ParmBlk" + ",AX"                  'use current environment
  ? #2,"Mov  ParmBlk" + "+2,Offset  $_0_"      'Offset  of $-> commandline
  ? #2,"Mov  ParmBlk" + "+4,DX"                'Segment of $-> commandline
  ? #2,"Mov  ParmBlk" + "+6,Offset  DummyFCB"  'Segment of $-> dummy fcb
  ? #2,"Mov  ParmBlk" + "+8,DX"                'Segment of $-> dummy fcb
  ? #2,"Mov  ParmBlk" + "+10,Offset DummyFCB"  'Segment of $-> dummy fcb
  ? #2,"Mov  ParmBlk" + "+12,DX"               'Segment of $-> dummy fcb
  ? #2,"Lea  DX,Comspec"                       'command.com
  ? #2,"Lea  BX,ParmBlk"                       'point to ParmBlk
  ? #2,"Mov  AH,4Bh"                           '(EXEC) function
  ? #2,"Xor  AL,AL"                            'Load & Execute Subfunction
  ? #2,"Push DS"                               'save some registers
  ? #2,"Push DS"
  ? #2,"Mov  [BP-6],SP"                        'save the stack Pointer
  ? #2,"Mov  [BP-4],SS"                        'save the stack segment
  ? #2,"Int  21h"                              'Call DOS
  ? #2,"Mov  SS,[BP-4]"                        'restore the registers
  ? #2,"Mov  SP,[BP-6]
  ? #2,"Pop  ES
  ? #2,"Pop  DS
  ? #2,"Mov  SP,BP
  ? #2,"Pop  BP
  ? #2,"Ret  02
  ? #2,"Shell Endp
  DoTwo
END IF



IF Use.FindFirst THEN
  DoTwo
  ? #2,"FindFirst Proc Near"
  ? #2,"Push CX"
  ? #2,"Push SI"
  ? #2,"Cld
  ? #2,"Mov  CX,13"
  ? #2,"Xor  AX,AX"
  ? #2,"Mov  DI,Offset $_1_"
  ? #2,"Rep  Stosb"
  ? #2,"Mov  DX,Offset $Dta"
  ? #2,"Mov  AH,1AH
  ? #2,"Int  21h"
  ? #2,"Pop  DX
  ? #2,"Pop  CX
  ? #2,"Mov  AH,4Eh
  ? #2,"Int  21h
  ? #2,"Call TrapError
  ? #2,"Mov  CX,12
  ? #2,"Mov  SI,Offset $Dta+30
  ? #2,"Mov  DI,Offset $_1_
  ? #2,"Cld
  ? #2,"Rep  Movs Byte Ptr [DI],Byte Ptr ES:[SI]"
  ? #2,"Mov  CX,12"
  ? #2,"Xor  AX,AX"
  ? #2,"Mov  DI,Offset $Dta+30"
  ? #2,"Cld
  ? #2,"Rep  Stosb
  ? #2,"Ret"
  ? #2,"FindFirst Endp"
  DoTwo
END IF


IF Use.FindNext THEN
  DoTwo
  ? #2,"FindNext Proc Near"
  ? #2,"Mov  CX,13"
  ? #2,"Xor  AX,AX"
  ? #2,"Mov  DI,Offset $_1_"
  ? #2,"Cld
  ? #2,"Rep  Stosb"
  ? #2,"Mov  AH,4Fh
  ? #2,"Int  21h
  ? #2,"Call TrapError
  ? #2,"Mov  CX,12
  ? #2,"Mov  SI,Offset $Dta+30
  ? #2,"Mov  DI,Offset $_1_
  ? #2,"Cld
  ? #2,"Rep  Movs Byte Ptr [DI],Byte Ptr ES:[SI]"
  ? #2,"Mov  CX,12"
  ? #2,"Xor  AX,AX"
  ? #2,"Mov  DI,Offset $Dta+30"
  ? #2,"Cld
  ? #2,"Rep  Stosb
  ? #2,"Ret"
  ? #2,"FindNext Endp"
  DoTwo
END IF



IF Use.Repeat THEN
  DoTwo
  ? #2,"Repeat$ Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Mov  DI,Offset $_1_
  ? #2,"Mov  [DI],Byte Ptr 0"
  ? #2,"Mov  CX,[BP+4]
  ? #2,"Cmp  CX,1"
  ? #2,"Jb   ReptXit"
  ? #2,"ReptLp:
  ? #2,"Mov  SI,[BP+6]
  ? #2,"Mov  DI,Offset $_1_
  ? #2,"Call Concat
  ? #2,"Loop ReptLp
  ? #2,"ReptXit:"
  ? #2,"Pop  BP
  ? #2,"Ret  04
  ? #2,"Repeat$ Endp
  DoTwo
END IF


IF Use.Replace THEN
  DoTwo
  ? #2,"Replace Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Sub  SP,6
  ? #2,"Mov  DI,Offset $_5_
  ? #2,"Mov  [DI],Byte Ptr 0
  ? #2,"Mov  DI,Offset $_0_
  ? #2,"Mov  [DI],Byte Ptr 0
  ? #2,"Mov  SI,Offset $_4_
  ? #2,"Call Len
  ? #2,"Mov  [BP-2],AX
  ? #2,"Mov  SI,Offset $_2_
  ? #2,"Call Len
  ? #2,"Mov  [BP-4],AX
  ? #2,"Xor  AX,AX
  ? #2,"Mov  [BP-6],AX
  ? #2,"Replc_1:
  ? #2,"Inc  Word Ptr[BP-6]
  ? #2,"Mov  AX,[BP-6]
  ? #2,"Cmp  AX,[BP-2]
  ? #2,"Jg   Replc_4
  ? #2,"Mov  SI,Offset $_4_
  ? #2,"Mov  DI,Offset $_1_
  ? #2,"Add  SI,[BP-6]
  ? #2,"Dec  SI
  ? #2,"Mov  CX,[BP-4]
  ? #2,"Cld
  ? #2,"Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI]
  ? #2,"Xor  AX,AX
  ? #2,"Mov  [DI],AL
  ? #2,"Mov  SI,Offset $_1_
  ? #2,"Mov  DI,Offset $_5_
  ? #2,"Call MoveStr
  ? #2,"Mov  SI,Offset $_5_
  ? #2,"Mov  DI,Offset $_2_
  ? #2,"Call StrCompare
  ? #2,"Jne  Replc_2
  ? #2,"Mov  SI,Offset $_3_
  ? #2,"Mov  DI,Offset $_0_
  ? #2,"Call Concat
  ? #2,"Mov  AX,[BP-4]
  ? #2,"Add  [BP-6],AX
  ? #2,"Dec  Word Ptr[BP-6]
  ? #2,"Jmp  Replc_3
  ? #2,"Replc_2:
  ? #2,"Mov  SI,Offset $_4_
  ? #2,"Mov  DI,Offset $_1_
  ? #2,"Add  SI,[BP-6]
  ? #2,"Dec  SI
  ? #2,"Mov  CX,1
  ? #2,"Cld
  ? #2,"Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI]
  ? #2,"Xor  AX,AX
  ? #2,"Mov  [DI],AL
  ? #2,"Call Concat_2
  ? #2,"Replc_3:
  ? #2,"Jmp  Replc_1
  ? #2,"Replc_4:
  ? #2,"Mov  SP,BP
  ? #2,"Pop  BP
  ? #2,"Ret
  ? #2,"Replace Endp
  DoTwo
END IF


IF Use.Peek THEN
  DoTwo
  ? #2,"Peek Proc Near
  ? #2,"Mov  DI,AX
  ? #2,"Push DS
  ? #2,"Push DefSeg
  ? #2,"Pop  DS
  ? #2,"Mov  AX,[DI]
  ? #2,"Pop  DS
  ? #2,"Xor  AH,AH
  ? #2,"Ret
  ? #2,"Peek Endp
  DoTwo
END IF


IF Use.Poke THEN
  DoTwo
  ? #2,"Poke Proc Near
  ? #2,"Push DS
  ? #2,"Mov  DS,DefSeg
  ? #2,"Mov  [DI],BL
  ? #2,"Pop  DS
  ? #2,"Ret
  ? #2,"Poke Endp
  DoTwo
END IF



IF Use.Peeki THEN
  DoTwo
  ? #2,"Peeki Proc Near
  ? #2,"Mov  DI,AX
  ? #2,"Push DS
  ? #2,"Push DefSeg
  ? #2,"Pop  DS
  ? #2,"Mov  AX,[DI]
  ? #2,"Pop  DS
  ? #2,"Ret
  ? #2,"Peeki Endp
  DoTwo
END IF


IF Use.Pokei THEN
  DoTwo
  ? #2,"Pokei Proc Near
  ? #2,"Push DS
  ? #2,"Mov  DS,DefSeg
  ? #2,"Mov  [DI],BX
  ? #2,"Pop  DS
  ? #2,"Ret
  ? #2,"Pokei Endp
  DoTwo
END IF


IF Use.Abs THEN
  DoTwo
  ? #2,"_Abs Proc Near
  ? #2,"Cmp  AX,32768
  ? #2,"Jb   Abs_1
  ? #2,"Neg  AX
  ? #2,"Abs_1:
  ? #2,"Ret
  ? #2,"_Abs Endp
  DoTwo
END IF



IF Use.Val THEN
  DoTwo
  ? #2,"Val Proc Near"      'DI = string TO Convert
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Sub  SP,2
  ? #2,"Xor  BX,BX"         'Used to accumulate binary Values
  ? #2,"Mov  [BP-2],BX"     'negative number flag
  ? #2,"Mov  SI,BX"         'power register : 1,10,100,1000,10000
  ? #2,"Mov  CX,1"          'counts number of Digits in String
  ? #2,"Val_1:"
  ? #2,"Mov  AX,[DI]"
  ? #2,"Xor  AH,AH"
  ? #2,"Cmp  AL,AH"         'is this the end of string?
  ? #2,"Je   Val_4"         'yes
  ? #2,"Cmp  AL,48"         'test for Valid Chars:  0123456789
  ? #2,"Jb   Val_2"
  ? #2,"Cmp  AL,57"
  ? #2,"Jg   Val_2"
  ? #2,"Sub  AL,'0'"         'Convert ascii to binary
  ? #2,"Push AX"
  ? #2,"Inc  SI"             'bump the number of Digits
  ? #2,"Val_2:"
  ? #2,"Cmp  AL,45"
  ? #2,"Jne Val_3"
  ? #2,"Mov Word Ptr[BP-2],1"
  ? #2,"Val_3:"
  ? #2,"Inc  DI"
  ? #2,"Jmp  Val_1"
  ? #2,"Val_4:"
  ? #2,"Cmp  SI,0"          'IF SI = 0 THEN no Valid Digits
  ? #2,"Je   Val_5"
  ? #2,"Pop  AX"            'get rightmost Digit
  ? #2,"Mul  CX"            'Multiply it by factor 1,10,100,1000,...
  ? #2,"Add  BX,AX"         'accumulate it
  ? #2,"Mov  AX,CX"         'get the factor 1,10,100,1000...
  ? #2,"Mov  CX,10"
  ? #2,"Mul  CX"            'Multiply factor by 10
  ? #2,"Mov  CX,AX"         'And  re-save it
  ? #2,"Dec  SI"            'get next Digit
  ? #2,"Cmp  SI,1"          'is it the leftmost Digit?
  ? #2,"Jge  Val_4"         'no
  ? #2,"Mov  AX,BX"         'yes...binary # In   AX
  ? #2,"Jmp  Val_6"
  ? #2,"Val_5:"
  ? #2,"Xor  AX,AX"         'get rid of cr
  ? #2,"Val_6:"
  ? #2,"Cmp  Word Ptr[BP-2],1"
  ? #2,"Jne  Val_7"
  ? #2,"Neg  AX"
  ? #2,"Val_7:"
  ? #2,"Mov  SP,BP
  ? #2,"Pop  BP
  ? #2,"Ret"
  ? #2,"Val Endp"
  DoTwo
END IF





IF Use.TrapError THEN
  DoTwo
  ? #2,"TrapError Proc Near
  ? #2,"Jnc  NoError
  ? #2,"Mov  Err,AX"
  ? #2,"NoError:
  ? #2,"Clc"
  ? #2,"Ret"
  ? #2,"TrapError Endp
  DoTwo
END IF




IF Use.Str THEN
  DoTwo
  ? #2,"Str$ Proc Near
  ? #2,"Cmp  BX,1
  ? #2,"Je   Str_1"
  ? #2,"Mov  [DI],Byte Ptr 32"
  ? #2,"Inc  DI
  ? #2,"Str_1:
  ? #2,"Xor  BX,BX
  ? #2,"Cmp  AX,32768
  ? #2,"Jb   Str_2
  ? #2,"Neg  AX
  ? #2,"Mov  [DI],Byte Ptr '-'"
  ? #2,"Inc  DI
  ? #2,"Str_2:
  ? #2,"Xor  CX,CX
  ? #2,"Mov  BX,10"
  ? #2,"Str_3:
  ? #2,"Inc  CX
  ? #2,"Xor  DX,DX
  ? #2,"Div  BX
  ? #2,"Push DX
  ? #2,"Cmp  AX,0
  ? #2,"Jne  Str_3
  ? #2,"Str_4:
  ? #2,"Pop  AX
  ? #2,"Add  AL,'0'
  ? #2,"Mov  [DI],AL
  ? #2,"Inc  DI
  ? #2,"Loop Str_4
  ? #2,"Xor  AX,AX
  ? #2,"Mov  [DI],AL
  ? #2,"Ret
  ? #2,"Str$ Endp
  DoTwo
END IF



IF Use.Space THEN
  DoTwo
  ? #2,"Space$ Proc Near
  ? #2,"Mov  CX,AX
  ? #2,"Mov  AL,32
  ? #2,"Cmp  CX,MaxString"
  ? #2,"Jg   Space_3
  ? #2,"Jcxz Space_2
  ? #2,"Space_1:
  ? #2,"Dec  CX
  ? #2,"Mov  [DI],AL
  ? #2,"Inc  DI
  ? #2,"Jcxz Space_2
  ? #2,"Jmp  Space_1
  ? #2,"Space_2:"
  ? #2,"Xor  AX,AX
  ? #2,"Mov  [DI],AL
  ? #2,"Space_3:
  ? #2,"Ret
  ? #2,"Space$ Endp
  DoTwo
END IF



IF Use.PrintNum THEN
  DoTwo
  ? #2,"PrintNum Proc Near
  ? #2,"Mov  DI,Offset $_1_
  ? #2,"Xor  BX,BX
  ? #2,"Call Str$
  ? #2,"Mov  SI,Offset $_1_
  ? #2,"Call PrintStr
  ? #2,"Call SetCursor
  ? #2,"Ret
  ? #2,"PrintNum Endp
  DoTwo
END IF


IF Use.GPrintNum THEN
  DoTwo
  ? #2,"GPrintNum Proc Near
  ? #2,"Mov  DI,Offset $_1_
  ? #2,"Xor  BX,BX
  ? #2,"Call Str$
  ? #2,"Mov  SI,Offset $_1_
  ? #2,"Call GPrint
  ? #2,"Call SetCursor
  ? #2,"Ret
  ? #2,"GPrintNum Endp
  DoTwo
END IF



IF Use.Ucase THEN
  DoTwo
  ? #2,"Ucase$ Proc Near
  ? #2,"Mov  DI,AX
  ? #2,"Mov  CX,MaxString"
  ? #2,"Cld
  ? #2,"Mov  SI,DI
  ? #2,"Ucase1:
  ? #2,"Lodsb
  ? #2,"Cmp  AL,'a'"
  ? #2,"Jb   Ucase2"
  ? #2,"Cmp  AL,'z'"
  ? #2,"Jg   Ucase2"
  ? #2,"Sub  AL,'a'-'A'"
  ? #2,"Ucase2:"
  ? #2,"Stosb
  ? #2,"Loop Ucase1
  ? #2,"Ret
  ? #2,"Ucase$ Endp
  DoTwo
END IF




IF Use.Lcase THEN
  DoTwo
  ? #2,"Lcase$ Proc Near
  ? #2,"Mov  DI,AX
  ? #2,"Mov  CX,MaxString"
  ? #2,"Cld
  ? #2,"Mov  SI,DI
  ? #2,"Lcase1:
  ? #2,"Lodsb
  ? #2,"Cmp  AL,'A'"
  ? #2,"Jb   Lcase2
  ? #2,"Cmp  AL,'Z'"
  ? #2,"Jg   Lcase2
  ? #2,"Sub  AL,'A'-'a'"
  ? #2,"Lcase2:
  ? #2,"Stosb
  ? #2,"Loop Lcase1
  ? #2,"Ret
  ? #2,"Lcase$ Endp
  DoTwo
END IF




IF Use.Instr THEN
  DoTwo
  ? #2,"_Instr Proc Near"     'Improved!  ex:  a = instr("111kev111","kev")
  ? #2,"Push BP"              '
  ? #2,"Call Len"             '12/25/95 based on a Ziff-Davis routine
  ? #2,"Mov  BX,AX"           'len of match
  ? #2,"Push SI"
  ? #2,"Mov  SI,DI"
  ? #2,"Call Len"
  ? #2,"Mov  DX,AX"           'len of main
  ? #2,"Pop  SI"
  ? #2,"Mov  BP,SI"           'save pattern offset
  ? #2,"Dec  BX"              'decr. pattern length by one
  ? #2,"Cld"
  ? #2,"Push DI"
  ? #2,"Instr_1:"
  ? #2,"Mov  SI,BP"           'AL := first char of pattern
  ? #2,"Lodsb"
  ? #2,"Mov  CX,DX"           'remaining searched string length
  ? #2,"Repnz Scasb"          'look for match on first char.
  ? #2,"Jnz  Instr_3"         'searched string exhausted,exit
  ? #2,"Mov  DX,CX"           'save new string length
  ? #2,"Mov  CX,BX"           'get pattern length - 1
  ? #2,"Repz Cmpsb"           'compare remainder of strings
  ? #2,"Jz   Instr_2"         'everything matched
  ? #2,"Add  DI,CX"           'no match,restore string addr
  ? #2,"Sub  DI,BX"           'advanced by one char.
  ? #2,"Cmp  DX,BX"           'searched string exhausted?
  ? #2,"Ja   Instr_1"         'some string left,try again
  ? #2,"Jmp  Instr_3"         'no match,jump to return
  ? #2,"Instr_2:"
  ? #2,"Sub  DI,BX"           'match found,let
  ? #2,"Mov  AX,DI"
  ? #2,"Pop  BX"
  ? #2,"Sub  AX,BX"
  ? #2,"Pop  BP"
  ? #2,"Ret"
  ? #2,"Instr_3:"
  ? #2,"Xor  AX,AX"            'no match,return CY=True
  ? #2,"Pop  BX"               'clean up the stack
  ? #2,"Pop  BP"
  ? #2,"Ret"
  ? #2,"_Instr Endp
  DoTwo
END IF



IF Use.Cls  THEN
  DoTwo
  ? #2,"Cls Proc Near
  ? #2,"Push BP
  ? #2,"Mov  $Xcur,1
  ? #2,"Mov  $Ycur,1
  ? #2,"Mov  AH,0Fh
  ? #2,"Int  10h
  ? #2,"Cmp  AL,3
  ? #2,"Jg   ClsGraphics
  ? #2,"Mov  AH,06
  ? #2,"Xor  AL,AL
  ? #2,"Mov  BX,$Attr
  ? #2,"Mov  BH,BL
  ? #2,"Xor  CX,CX
  ? #2,"Mov  DH,24
  ? #2,"Mov  DL,79
  ? #2,"Int  10h
  ? #2,"Xor  BX,BX
  ? #2,"Xor  DX,DX
  ? #2,"Mov  AH,02
  ? #2,"Int  10h
  ? #2,"Jmp  ClsEnd
  ? #2,"ClsGraphics:
  ? #2,"Mov  BX,BgColor
  ? #2,"Xchg BH,BL
  ? #2,"Xor  CX,CX
  ? #2,"Mov  DL,79"
  ? #2,"Mov  DH,43"
  ? #2,"Mov  AX,0600h
  ? #2,"Int  10h
  ? #2,"ClsEnd:
  ? #2,"Pop  BP
  ? #2,"Ret
  ? #2,"Cls  Endp
  DoTwo
END IF


IF Use.PrintStr THEN
  Use.DoCrLf=%True
  DoTwo
  ? #2,"PrintStr Proc Near"
  ? #2,"Call Len
  ? #2,"Push AX
  ? #2,"Mov  CX,AX
  ? #2,"Cmp  CX,0"
  ? #2,"Jle  PS_3
  ? #2,"Mov  BX,$Attr"
  ? #2,"Mov  AX,$Ycur"
  ? #2,"Mov  DI,$Xcur"
  ? #2,"Push DS"
  ? #2,"Push ES"
  ? #2,"Dec  AX"
  ? #2,"Dec  DI"
  ? #2,"Cmp  DI,0"
  ? #2,"Jg   PS_1"
  ? #2,"Xor  DI,DI"
  ? #2,"PS_1:"
  ? #2,"Mov  DX,80"
  ? #2,"Mul  DX"
  ? #2,"Add  DI,AX"
  ? #2,"Shl  DI,1"
  ? #2,"Mov  AX,0B000H"
  ? #2,"Mov  ES,AX"
  ? #2,"Mov  AH,0FH"
  ? #2,"Int  10H"
  ? #2,"Cmp  AL,07H"
  ? #2,"Je   PS_2"
  ? #2,"Mov  AX,0B800H"
  ? #2,"Mov  ES,AX"
  ? #2,"PS_2:"
  ? #2,"Cld"
  ? #2,"Movsb"
  ? #2,"Mov  ES:[DI],BL"
  ? #2,"Inc  DI"
  ? #2,"Loop PS_2"
  ? #2,"Pop  ES"
  ? #2,"Pop  DS"
  ? #2,"PS_3:"
  ? #2,"Pop  AX
  ? #2,"Add  $Xcur,AX
  ? #2,"Ret"
  ? #2,"PrintStr Endp"
  DoTwo
END IF


IF Use.Trim THEN
  DoTwo
  ? #2,"Trim$ Proc Near"                     'SI=input   $_1_=output
  ? #2,"Mov  DI,Offset $_2_
  ? #2,"Call MoveStr
  ? #2,"Mov  SI,Offset $_2_
  ? #2,"Call Ltrim$
  ? #2,"Mov  SI,Offset $_1_
  ? #2,"Mov  DI,Offset $_2_
  ? #2,"Call MoveStr
  ? #2,"Mov  SI,Offset $_2_
  ? #2,"Call Rtrim$
  ? #2,"Ret
  ? #2,"Trim$ Endp
  DoTwo
END IF


IF Use.Rtrim THEN
  DoTwo
  ? #2,"Rtrim$ Proc Near"         'SI=address of String TO rtrim
  ? #2,"Mov  DI,Offset $_2_"      '* Note * trims ALL Chars 0 TO 32
  ? #2,"Call MoveStr"
  ? #2,"Mov  SI,Offset $_2_"
  ? #2,"Mov  DI,Offset $_1_
  ? #2,"Call MoveStr
  ? #2,"Mov  SI,Offset $_1_
  ? #2,"Call Len
  ? #2,"Mov  DI,Offset $_1_
  ? #2,"Mov  CX,AX
  ? #2,"Add  DI,AX
  ? #2,"Rtrim1:
  ? #2,"Mov  BL,[DI]
  ? #2,"Cmp  BL,32
  ? #2,"Jg   Rtrim2
  ? #2,"Xor  AX,AX
  ? #2,"Mov  [DI],AL
  ? #2,"Dec  CX
  ? #2,"Dec  DI
  ? #2,"Cmp  CX,0
  ? #2,"Jge  Rtrim1
  ? #2,"Rtrim2:
  ? #2,"Ret
  ? #2,"Rtrim$ Endp
  DoTwo
END IF


IF Use.Ltrim THEN
  DoTwo
  ? #2,"Ltrim$ Proc Near"       ' SI =  $_2_     Output String In $_1_
  ? #2,"Mov  DI,Offset $_2_"
  ? #2,"Call MoveStr"
  ? #2,"Mov  SI,Offset $_2_"
  ? #2,"Xor  CX,CX
  ? #2,"Ltrim1:
  ? #2,"Cmp  [SI],Byte Ptr 32
  ? #2,"Jne  Ltrim2
  ? #2,"Inc  SI
  ? #2,"Inc  CX
  ? #2,"Cmp  CX,MaxString"
  ? #2,"Jne  Ltrim1
  ? #2,"Ltrim2:
  ? #2,"Mov  CX,MaxString"
  ? #2,"Mov  DI,Offset $_1_
  ? #2,"Cld
  ? #2,"Rep  Movs Byte Ptr [DI],Byte Ptr ES:[SI]
  ? #2,"Ret
  ? #2,"Ltrim$ Endp
  DoTwo
END IF


IF Use.Extract THEN
  DoTwo
  ? #2,"Extract$ Proc Near"         'SI = main$
  ? #2,"Mov  AL,[DI]"               'DI = Match$     Len Match$ = 1 only
  ? #2,"Mov  DI,Offset $_1_
  ? #2,"Xor  CX,CX
  ? #2,"Extr1:
  ? #2,"Mov  BL,[SI]
  ? #2,"Cmp  BL,AL
  ? #2,"Je   Extr2
  ? #2,"Mov  [DI],BL
  ? #2,"Inc  DI
  ? #2,"Inc  SI
  ? #2,"Inc  CX
  ? #2,"Cmp  CX,MaxString"
  ? #2,"Jne  Extr1
  ? #2,"Extr2:
  ? #2,"Xor  AX,AX
  ? #2,"Mov  [DI],AL
  ? #2,"Ret
  ? #2,"Extract$ Endp
  DoTwo
END IF



IF Use.DiskInput THEN
  DoTwo
  ? #2,"DiskInput Proc Near"     'DI = destination String
  ? #2,"Mov  $Handle,AX
  ? #2,"Xor  AX,AX
  ? #2,"Mov  SI,AX
  ? #2,"Mov  [DI],AL
  ? #2,"Mov  Eof,AX
  ? #2,"DiskInLoop:
  ? #2,"Xor  CX,CX
  ? #2,"Mov  $_1_,CL
  ? #2,"Inc  CX"
  ? #2,"Mov  BX,$Handle
  ? #2,"Mov  DX,Offset $_1_
  ? #2,"Mov  AH,3fh
  ? #2,"Int  21h
  ? #2,"Cmp  AX,1
  ? #2,"Je   DiskInOk
  ? #2,"Mov  Eof,-1
  ? #2,"Jmp  DiskInExit
  ? #2,"DiskInOk:
  ? #2,"Cmp  $_1_,13
  ? #2,"Je   DiskInLF
  ? #2,"Cmp  $_1_,44
  ? #2,"Je   DiskInExit
  ? #2,"Cmp  $_1_,26
  ? #2,"Je   DiskEof
  ? #2,"Mov  AL,$_1_
  ? #2,"Mov  [DI],AL
  ? #2,"Inc  DI
  ? #2,"Inc  SI
  ? #2,"Cmp  SI,MaxString"
  ? #2,"Jne  DiskInLoop
  ? #2,"DiskInLF:
  ? #2,"Xor  CX,CX"
  ? #2,"Mov  $_1_,CL
  ? #2,"Inc  CX"
  ? #2,"Mov  BX,$Handle
  ? #2,"Mov  DX,Offset $_1_
  ? #2,"Mov  AH,3fh
  ? #2,"Int  21h
  ? #2,"DiskInExit:
  ? #2,"Xor  AX,AX
  ? #2,"Mov  [DI],AL
  ? #2,"Ret
  ? #2,"DiskEof:
  ? #2,"Mov  Eof,-1
  ? #2,"Xor  AX,AX
  ? #2,"Mov  [DI],AL
  ? #2,"Ret"
  ? #2,"DiskInput Endp
  DoTwo
END IF




IF Use.LineInput THEN
  DoTwo
  ? #2,"LineInput Proc Near
  ? #2,"Pusha
  ? #2,"Mov  BX,AX"                 'DS:DX = Buffer Address
  ? #2,"Mov  CX,255"                'BX = Handle
  ? #2,"Mov  DX,Offset $FileBuf"
  ? #2,"Mov  AH,3fh"                'Function 3FH = read
  ? #2,"Int  21h"                   'call MS-DOS
  ? #2,"Jc   LinPut6"               'Jump if read error
  ? #2,"Or   AX,AX"                 'end of file?
  ? #2,"Jz   LinPut6"               'yes,Jump
  ? #2,"Push AX"                    'save actual data length
  ? #2,"Push BX"                    'save input file handle
  ? #2,"Push DX"                    'save buffer base Address
  ? #2,"Push DS"
  ? #2,"Push DX"
  ? #2,"Pop  DI"
  ? #2,"Mov  DX,AX"                 'DX = string length
  ? #2,"Mov  SI,Offset $CrLf"
  ? #2,"Mov  BX,2"                  'BX = delimiter length
  ? #2,"Mov  BP,SI"                 'save pattern Offset
  ? #2,"Dec  BX"                    'Decr. pattern length by one
  ? #2,"Cld"
  ? #2,"LinPut2:"
  ? #2,"Mov  SI,BP"                 'AL := first char of pattern
  ? #2,"Lodsb"
  ? #2,"Mov  CX,DX"                 'remaining searched string length
  ? #2,"Repnz Scasb"                'look for match on first char.
  ? #2,"Jnz  LinPut4"               'searched string exhausted,exit
  ? #2,"Mov  DX,CX"                 'save new string length
  ? #2,"Mov  CX,BX"                 'get pattern length - 1
  ? #2,"Repz Cmpsb"                 'compare remainder of strings
  ? #2,"Jz   LinPut3"               'everything matched
  ? #2,"Add  DI,CX"                 'no match,restore string Addr
  ? #2,"Sub  DI,BX"                 'advanced by one char.
  ? #2,"Cmp  DX,BX"                 'searched string exhausted?
  ? #2,"Ja   LinPut2"               'some string left,try again
  ? #2,"Jmp  LinPut4"               'no match,Jump to return
  ? #2,"LinPut3:"
  ? #2,"Sub  DI,BX"                 'match found,let
  ? #2,"Dec  DI"                    'ES:DI = matched string Addr.
  ? #2,"Clc"                        'and return CY=False
  ? #2,"Jmp LinPut5"
  ? #2,"LinPut4:"
  ? #2,"Stc"                        'no match,set the carry
  ? #2,"LinPut5:"
  ? #2,"Mov  BX,DI"
  ? #2,"Mov  [BX],Byte Ptr 0"
  ? #2,"Pop  DS"                    'restore buffer base Address
  ? #2,"Pop  DX"
  ? #2,"Pop  BX"                    'restore input file handle
  ? #2,"Pop  AX"                    'restore Original read lengths
  ? #2,"Jc   LinPut6"               'Jump if no delimiter found
  ? #2,"Add  DI,2"                  'account for crlf
  ? #2,"Sub  DI,DX"
  ? #2,"Push DI"                    'and save it
  ? #2,"Sub  AX,DI"                 'calculate read excess
  ? #2,"Neg  AX"
  ? #2,"Cwd"
  ? #2,"Mov  CX,AX"                 'CX:DX = amount to back
  ? #2,"Xchg DX,CX"                 'up file poInter
  ? #2,"Mov  AX,4201h"              'Function 42H = seek
  ? #2,"Int  21h"                   'transfer to MS-DOS
  ? #2,"Pop  AX"                    'get back line length
  ? #2,"Jmp  LinPut7"               'and return it to caller
  ? #2,"LinPut6:"
  ? #2,"Call TrapError"
  ? #2,"Mov  Eof,1"		    'set line length = 0
  ? #2,"Mov  BX,DX"
  ? #2,"Mov  [BX],Byte Ptr 0"
  ? #2,"LinPut7:"
  ? #2,"Popa
  ? #2,"Ret"
  ? #2,"LineInput Endp"
  DoTwo
END IF






IF Use.Delay THEN
  DoTwo
  ? #2,"Delay Proc Near
  ? #2,"Mul  BL
  ? #2,"Mov  BX,AX
  ? #2,"Xor  AH,AH
  ? #2,"Int  1AH
  ? #2,"Add  BX,DX
  ? #2,"DlyLp:
  ? #2,"Xor  AH,AH
  ? #2,"Int  1AH
  ? #2,"Cmp  DX,BX
  ? #2,"Jne  DlyLp
  ? #2,"Ret
  ? #2,"Delay Endp
  DoTwo
END IF



IF Use.Beep THEN
  DoTwo
  ? #2,"Beep Proc Near"
  ? #2,"In   AL,61h"
  ? #2,"Or   AL,3"
  ? #2,"Out  61h,AL"
  ? #2,"Mov  AL,5"
  ? #2,"Out  42h,AL"
  ? #2,"Mov  BX,3"
  ? #2,"Xor  AH,AH"
  ? #2,"Int  1AH"
  ? #2,"Add  BX,DX"
  ? #2,"BpDlyLp:"
  ? #2,"Xor  AH,AH"
  ? #2,"Int  1AH"
  ? #2,"Cmp  DX,BX"
  ? #2,"Jne  BpDlyLp"
  ? #2,"In   AL,61h"
  ? #2,"And  AL,Not 3"
  ? #2,"Out  61h,AL"
  ? #2,"Ret"
  ? #2,"Beep Endp"
  DoTwo
END IF


IF Use.DoCrLf THEN
  DoTwo
  ? #2,"DoCrLf Proc Near
  ? #2,"Mov  $Xcur,1
  ? #2,"Inc  $Ycur
  ? #2,"Cmp  $Ycur,26
  ? #2,"Jne  CrLf_1
  ? #2,"Dec  $Ycur
  ? #2,"CrLf_1:
  ? #2,"Mov  DX,Offset $CrLf
  ? #2,"Mov  AH,9
  ? #2,"Int  21h
  ? #2,"Mov  BX,$Xcur"
  ? #2,"Mov  DL,BL"
  ? #2,"Dec  DL"
  ? #2,"Mov  BX,$Ycur"
  ? #2,"Mov  DH,BL"
  ? #2,"Dec  DH"
  ? #2,"Xor  BX,BX
  ? #2,"Mov  AH,2"
  ? #2,"Int  10h"
  ? #2,"Ret
  ? #2,"DoCrLf Endp
  DoTwo
END IF


IF Use.Instat THEN
  DoTwo
  ? #2,"Instat Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Mov  AH,0Bh
  ? #2,"Int  21h
  ? #2,"Xor  AH,AH
  ? #2,"Cmp  AX,0
  ? #2,"Je   InstatQuit
  ? #2,"Mov  AX,-1
  ? #2,"InstatQuit:
  ? #2,"Pop  BP
  ? #2,"Ret
  ? #2,"Instat Endp
  DoTwo
END IF


IF Use.Mod THEN
  DoTwo
  ? #2,"Modd Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Xor  DX,DX
  ? #2,"Mov  AX,[BP+6]
  ? #2,"Mov  CX,[BP+4]
  ? #2,"Idiv CX
  ? #2,"Mov  AX,DX
  ? #2,"Xor  DX,DX
  ? #2,"Mov  $Var0,DX
  ? #2,"Pop  BP
  ? #2,"Ret  04
  ? #2,"Modd Endp
  DoTwo
END IF



IF Use.Sgn = %True THEN
  DoTwo
  ? #2,"Sgn Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Xor  AX,AX
  ? #2,"Cmp  [BP+4],AX
  ? #2,"Jne  Sgn_1
  ? #2,"Pop  BP
  ? #2,"Ret  02
  ? #2,"Sgn_1:
  ? #2,"Cmp  [BP+4],AX
  ? #2,"Jle  Sgn_2
  ? #2,"Inc  AX
  ? #2,"Pop  BP
  ? #2,"Ret  02
  ? #2,"Sgn_2:
  ? #2,"Cmp  [BP+4],AX
  ? #2,"Jge  Sgn_3
  ? #2,"Dec  AX
  ? #2,"Sgn_3:
  ? #2,"Pop  BP
  ? #2,"Ret  02
  ? #2,"Sgn  Endp
  DoTwo
END IF


IF Use.KBinput THEN
  DoTwo
  ? #2,"kbInput Proc Near
  ? #2,"Mov  AX,$Xcur
  ? #2,"Mov  $Var1,AX
  ? #2,"Mov  AX,$Ycur
  ? #2,"Mov  $Var2,AX
  ? #2,"Call SetCursor
  ? #2,"Xor  BX,BX
  ? #2,"Mov  CX,255
  ? #2,"Mov  DX,Offset $_0_
  ? #2,"Mov  AH,3fh
  ? #2,"Int  21h
  ? #2,"Mov  $Var3,AX
  ? #2,"Mov  SI,Offset $_0_
  ? #2,"Dec  SI
  ? #2,"KBFindCR:
  ? #2,"Inc  SI
  ? #2,"Mov  AL,ES:[SI]
  ? #2,"Cmp  AL,13
  ? #2,"Jne  KBFindCR
  ? #2,"Xor  AX,AX
  ? #2,"Mov  ES:[SI],AL
  ? #2,"Call GetCursor
  ? #2,"Ret
  ? #2,"kbInput Endp
  DoTwo
END IF


IF Use.Left THEN
  DoTwo
  ? #2,"Left$ Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Mov  SI,[BP+4]
  ? #2,"Mov  DI,Offset $_1_
  ? #2,"Mov  CX,[BP+6]
  ? #2,"Cld
  ? #2,"Rep  Movs Byte Ptr [DI],Byte Ptr ES:[SI]
  ? #2,"Xor  AX,AX
  ? #2,"Mov  [DI],AL
  ? #2,"Pop  BP
  ? #2,"Ret  04
  ? #2,"Left$ Endp
  DoTwo
END IF


IF Use.Right THEN
  DoTwo
  ? #2,"Right$ Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Sub  SP,2
  ? #2,"Xor  AX,AX
  ? #2,"Mov  [BP-2],AX
  ? #2,"Mov  SI,[BP+4]
  ? #2,"Call Len
  ? #2,"Sub  AX,[BP+6]
  ? #2,"Inc  AX
  ? #2,"Mov  [BP-2],AX
  ? #2,"Cmp  AX,0
  ? #2,"Jge  Right_01
  ? #2,"Mov  AX,1
  ? #2,"Mov  [BP-2],AX
  ? #2,"Right_01:
  ? #2,"Mov  DI,Offset $_1_
  ? #2,"Mov  [DI],Byte Ptr 0"
  ? #2,"Mov  SI,[BP+4]
  ? #2,"Mov  DI,Offset $_1_
  ? #2,"Add  SI,[BP-2]
  ? #2,"Dec  SI
  ? #2,"Mov  CX,MaxString"
  ? #2,"Sub  CX,[BP-2]
  ? #2,"Cld
  ? #2,"Rep  Movs Byte Ptr [DI],Byte Ptr ES:[SI]
  ? #2,"Xor  AX,AX
  ? #2,"Mov  [DI],AL
  ? #2,"Mov  SP,BP
  ? #2,"Pop  BP
  ? #2,"Ret  04
  ? #2,"Right$ Endp
  DoTwo
END IF


IF Use.ClrWork = %True THEN
  DoTwo
  ? #2,"ClrWork Proc Near
  ? #2,"Mov  DI,Offset $_0_
  ? #2,"Xor  AX,AX
  ? #2,"Mov  [DI],AX
  ? #2,"Ret
  ? #2,"ClrWork Endp
  DoTwo
END IF


IF Use.ConcatWork = %True THEN
  DoTwo
  ? #2,"ConcatWork Proc Near
  ? #2,"Mov  DI,Offset $_0_"
  ? #2,"Call Concat
  ? #2,"Ret
  ? #2,"ConcatWork Endp
  DoTwo
END IF


IF Use.Assign = %True THEN
  DoTwo
  ? #2,"Assign Proc Near
  ? #2,"Mov  SI,Offset $_0_
  ? #2,"Call MoveStr
  ? #2,"Ret
  ? #2,"Assign Endp
  DoTwo
END IF


IF Use.Mid = %True THEN
  DoTwo
  ? #2,"Mid$ Proc Near
  ? #2,"Push BX
  ? #2,"Push AX
  ? #2,"Call ClrWork
  ? #2,"Cld
  ? #2,"Mov  DI,Offset $_1_
  ? #2,"Pop  AX
  ? #2,"Add  SI,AX
  ? #2,"Dec  SI
  ? #2,"Pop  CX
  ? #2,"Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI]
  ? #2,"Mov  [DI],Byte Ptr 0
  ? #2,"Ret
  ? #2,"Mid$ Endp
  DoTwo
END IF


IF Use.Getkey THEN
  DoTwo
  ? #2,"Getkey Proc Near
  ? #2,"Xor  AX,AX
  ? #2,"Int  16h
  ? #2,"Cmp  AL,0
  ? #2,"Je   GetKey_1
  ? #2,"Xor  AH,AH
  ? #2,"Jmp  GetKey_2
  ? #2,"GetKey_1:
  ? #2,"Mov  AL,AH
  ? #2,"Xor  AH,AH
  ? #2,"Neg  AX
  ? #2,"GetKey_2:
  ? #2,"Ret
  ? #2,"GetKey Endp
  DoTwo
END IF


IF Use.Inkey THEN
  DoTwo
  ? #2,"Inkey Proc Near
  ? #2,"Mov  AH,06h
  ? #2,"Mov  DL,0FFh
  ? #2,"Int  21h
  ? #2,"Jz   NoKey
  ? #2,"Xor  AH,AH
  ? #2,"Ret
  ? #2,"NoKey:
  ? #2,"Xor  AX,AX
  ? #2,"Ret
  ? #2,"InKey Endp
  DoTwo
END IF



IF Use.Time =%True THEN
  DoTwo
  ? #2,"Time Proc Near
  ? #2,"Push BP
  ? #2,"Mov  AH,2ch
  ? #2,"Int  21h
  ? #2,"Mov  DI,Offset $_1_
  ? #2,"Xor  AH,AH
  ? #2,"Mov  AL,CH"                'hours
  ? #2,"Push CX
  ? #2,"Push DX
  ? #2,"Call Tim_3
  ? #2,"Pop  DX
  ? #2,"Pop  CX
  ? #2,"Mov  [DI],Byte Ptr ':'
  ? #2,"Xor  AH,AH"                'mins
  ? #2,"Mov  AL,CL
  ? #2,"Push DX
  ? #2,"Inc  DI
  ? #2,"Call Tim_6
  ? #2,"Tim_1:
  ? #2,"Call Tim_3
  ? #2,"Pop  DX
  ? #2,"Mov  [DI],Byte Ptr ':'
  ? #2,"Inc  DI
  ? #2,"Mov  AL,DH
  ? #2,"Call Tim_6
  ? #2,"Tim_2:
  ? #2,"Call Tim_3
  ? #2,"Mov  [DI],Byte Ptr 0
  ? #2,"Pop  BP
  ? #2,"Ret
  ? #2,"Tim_3:
  ? #2,"Xor  CX,CX
  ? #2,"Mov  BX,10
  ? #2,"Tim_4:
  ? #2,"Inc  CX
  ? #2,"Xor  DX,DX
  ? #2,"Div  BX
  ? #2,"Push DX
  ? #2,"Cmp  AX,0
  ? #2,"Jne  Tim_4
  ? #2,"Tim_5:
  ? #2,"Pop  AX
  ? #2,"Add  AL,'0'
  ? #2,"Mov  [DI],AL
  ? #2,"Inc  DI
  ? #2,"Loop Tim_5
  ? #2,"Ret
  ? #2,"Tim_6:
  ? #2,"Cmp  AX,9"                 'if only 1 digit
  ? #2,"Jg   Tim_7
  ? #2,"Mov  [DI],Byte Ptr '0'"     'then pad with zero
  ? #2,"Inc  DI
  ? #2,"Tim_7:
  ? #2,"Ret
  ? #2,"Time Endp
  DoTwo
END IF



IF Use.Date THEN
  DoTwo
  ? #2,"Date Proc Near
  ? #2,"Push BP
  ? #2,"Mov  AH,2ah
  ? #2,"Int  21h
  ? #2,"Mov  DI,Offset $_1_
  ? #2,"Xor  AH,AH
  ? #2,"Mov  AL,DH
  ? #2,"Push CX
  ? #2,"Push DX
  ? #2,"Call Dat_6
  ? #2,"Call Dat_3
  ? #2,"Pop  DX
  ? #2,"Pop  CX
  ? #2,"Mov  [DI],Byte Ptr '-'
  ? #2,"Xor  AH,AH
  ? #2,"Mov  AL,DL
  ? #2,"Push CX
  ? #2,"Inc  DI
  ? #2,"Call Dat_6
  ? #2,"Dat_1:
  ? #2,"Call Dat_3
  ? #2,"Pop  CX
  ? #2,"Mov  [DI],Byte Ptr '-'
  ? #2,"Inc  DI
  ? #2,"Mov  AX,CX
  ? #2,"Call Dat_6
  ? #2,"Dat_2:
  ? #2,"Call Dat_3
  ? #2,"Mov  [DI],Byte Ptr 0
  ? #2,"Pop  BP
  ? #2,"Ret
  ? #2,"Dat_3:
  ? #2,"Xor  CX,CX
  ? #2,"Mov  BX,10
  ? #2,"Dat_4:
  ? #2,"Inc  CX
  ? #2,"Xor  DX,DX
  ? #2,"Div  BX
  ? #2,"Push DX
  ? #2,"Cmp  AX,0
  ? #2,"Jne  Dat_4
  ? #2,"Dat_5:
  ? #2,"Pop  AX
  ? #2,"Add  AL,'0'
  ? #2,"Mov  [DI],AL
  ? #2,"Inc  DI
  ? #2,"Loop Dat_5
  ? #2,"Ret
  ? #2,"Dat_6:
  ? #2,"Cmp  AX,9
  ? #2,"Jg   Dat_7
  ? #2,"Mov  [DI],Byte Ptr '0'"
  ? #2,"Inc  DI
  ? #2,"Dat_7:
  ? #2,"Ret
  ? #2,"Date Endp
  DoTwo
END IF


IF Use.Curdrive = %True THEN
  DoTwo
  ? #2,"Curdrive$ Proc Near
  ? #2,"Mov  AH,19h
  ? #2,"Int  21h
  ? #2,"Add  AL,65
  ? #2,"Mov  $_1_,al
  ? #2,"Mov  $_1_+1,0
  ? #2,"Ret
  ? #2,"Curdrive$ Endp
  DoTwo
END IF
